﻿//DESCRIPTION: 1, 2, 4, 5, 6 -> 1, 2, 4-6    
// groupSequentiellNum.2jsx   
// Connection of consecutive numbers
// https://indesign.hilfdirselbst.ch/2010/11/verbindung-von-aufeinanderfolgenden-zahlen-durch-bis-strich-2.html
   
   
if (app.selection.length > 0 && app.selection[0].hasOwnProperty ('baseline')) 
{ 
    var s = app.selection[0].parentStory;   
    app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;   
       
    app.findGrepPreferences.findWhat = '\\d+, ([\\d+, ])+';   
    var  r = s.findGrep();   
    for ( aLine = r.length-1; aLine >= 0; aLine-- )   
        r[aLine].contents= checkOneLine ( r[aLine].contents );   
} 
else 
    alert( 'Warning!\nPlease select a section of text.' );     
 
   
function checkOneLine ( aString )   
{   
    var  a = aString.split(  ', ' );   
    for ( var i = 0; i < aString.length-1; i++ )   
    {   
        k = i + 1;  
        while ( k < aString.length && a[k] == Number( a[k-1] ) + 1)   
        {   
            k++;   
        }   
        if ( k > i+2 && Number(a[k-1]) >  Number( a[i] ) )  // 1, 2, 4, 5, 6 -> 1, 2, 4-6      
        {   
            a[i] = a[i] + '–' + a[k-1];   
            a.splice( i+1, k-1-i );   
        }   
    }   
    return  a.join( ', ');   
} 